#include <stdarg.h>
#include <string.h>
#include "ggi_widget.h"
#include "ggi_widget_internal.h"

static int label_getsize(ggi_widget_t self) {

	int xm=0;
	int ym=0;
	
	int xx=0;
	
	char *text=(char *)self->priv;	

	self->min.x=self->min.y=
	self->opt.x=self->opt.y=0;

	if (!text) {
		text=self->statevar;
		if (!text) return 1;
	}

	while(*text) {
		if (*text=='\n') {
			if (xx>xm) xm=xx;
			xx=0;ym++;text++;
			continue;
		}
		xx++;text++;
	}
	if (xx!=0) ym++;
	if (xx>xm) xm=xx;
	self->min.x=self->opt.x=xm*8;
	self->min.y=self->opt.y=ym*8;

	return 0;
}

static int label_puts(ggi_widget_t self,int x,int y,char *text,int dsx) {

	int ym=0;
	int xx=0;
	dsx/=8;
	
	if (!text) return 1;

	while(*text) {
		if (*text=='\n') {
			while(xx<dsx) {ggiPutc(self->vis,x+xx*8,y+ym*8,' ');xx++;}
			xx=0;ym++;text++;
			continue;
		}
		ggiPutc(self->vis,x+xx*8,y+ym*8,*text);
		xx++;text++;
	}
	while(xx<dsx) {ggiPutc(self->vis,x+xx*8,y+ym*8,' ');xx++;}
	return 0;
}

static int ggiWidgetLabelRedraw(ggi_widget_t self,int flush) {

	char *text=(char *)self->priv;
	ggi_widget_size_t drawpos,drawsize;
	ggi_widget_color_set *colset=ggiWidgetGetColorset(self);
	
	if (!text) {
		struct ggiWidgetSize oldsize;
		text=self->statevar;
		if (!text) return 1;
		oldsize=self->min;
		label_getsize(self);
		if (oldsize.x!=self->min.x||oldsize.y!=self->min.x) {
			self->parent->childchanged(self->parent,self);
		}
	}

	ggiWidgetGetPlacement(self,&drawpos,&drawsize,NULL,1,1);
	ggiWidgetDrawBorder(self,&drawpos,&drawsize);

	ggiSetGCForeground(self->vis,ggiMapColor(self->vis,&colset->text));
	ggiSetGCBackground(self->vis,ggiMapColor(self->vis,&colset->background));
	
	label_puts(self,self->pos.x+drawpos.x,self->pos.y+drawpos.y,text,drawsize.x);
	if (flush)
		ggiFlushRegion(self->vis,self->pos.x,self->pos.y,self->size.x,self->size.y);
	return 0;
}

static int ggiWidgetLabelChildchanged(ggi_widget_t self,ggi_widget_t child) {

	label_getsize(self);	/* Recalc my size */
	
	if (self->parent) self->parent->childchanged(self->parent,self);
	else              self->vischanged(self);

	return 0;
}


ggi_widget_t ggiWidgetCreateLabel(va_list ap) {

	ggi_widget_t newid;

	char *text;
	
	newid=ggiWidgetAllocate();
	if (!newid) return NULL;

	text=va_arg(ap,char *);
	if (text) {
		newid->priv=strdup(text);
		if (!newid->priv) {
			free(newid);
			return NULL;
		}
	} else
		newid->priv=NULL;

	label_getsize(newid);
	newid->max.x=newid->max.y=-1;
	newid->redraw=ggiWidgetLabelRedraw;
	newid->childchanged=ggiWidgetLabelChildchanged;

	return newid;
}
